
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Sync_Mealy_Machine is
    Port ( A,B,Clk : in   STD_LOGIC;
	        State:    out STD_LOGIC_VECTOR(3 downto 0);
           F :       out  STD_LOGIC);
end Sync_Mealy_Machine;

architecture Behavioral of Sync_Mealy_Machine is
   signal   Q:      STD_LOGIC := '0';
	constant State0: STD_LOGIC := '0'; -- State OR
	constant State1: STD_LOGIC := '1'; -- State AND
	
begin
   process( Clk)
	begin
	   if rising_edge( Clk) then
		   case Q is
			    when State0 => if A='1' and B='1' then
										 Q <= State1;
									 end if;	 
			    when state1 => if A='0' and B='0' then
										 Q <= State0;
                            end if;
				 when others => null;
			 end case;
		end if;
   end process;
	
	F <= A and B when Q=State1 else
	     A or  B;
		  
   State <= "000"&Q;	  
end Behavioral;

