
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Sync_Moore_Machine is
    Port ( A,B,Clk : in  STD_LOGIC;
	        State:    out STD_LOGIC_VECTOR(3 downto 0);
           F :       out STD_LOGIC);
end Sync_Moore_Machine;

architecture Behavioral of Sync_Moore_Machine is
   signal   Q:     STD_LOGIC_VECTOR(1 downto 0) := "00";
	constant OR_0:  STD_LOGIC_VECTOR(1 downto 0) := "00"; 
	constant OR_1:  STD_LOGIC_VECTOR(1 downto 0) := "01"; 
	constant AND_0: STD_LOGIC_VECTOR(1 downto 0) := "10"; 
	constant AND_1: STD_LOGIC_VECTOR(1 downto 0) := "11"; 	
begin

   process( Clk)
	begin
	   if rising_edge( Clk) then
		   case Q is
			    when OR_0 => if A='1' and B='1' then
										 Q <= AND_1;
									elsif A='1' or B='1' then
									    Q <= OR_1;
									end if;
			    when OR_1 => if A='1' and B='1' then
										 Q <= AND_1;
									elsif A='0' and B='0' then
									    Q <= OR_0;
									end if;									
			    when AND_0 => if A='1' and B='1' then
										 Q <= AND_1;
									elsif A='0' and B='0' then
									    Q <= OR_0;
									end if;
			    when AND_1 => if A='0' and B='0' then
										 Q <= OR_0;
									elsif A='0' or B='0' then
									    Q <= AND_0;
									end if;									
				 when others => null;
			 end case;
		end if;
   end process;

   F <= Q(0);
	
	State <= "00"&Q;
end Behavioral;

