VERSION 6
BEGIN SCHEMATIC
    BEGIN ATTR DeviceFamilyName "spartan3e"
        DELETE all:0
        EDITNAME all:0
        EDITTRAIT all:0
    END ATTR
    BEGIN NETLIST
        SIGNAL F_Moore
        SIGNAL F_Mealy
        SIGNAL F_Async
        SIGNAL XLXN_62
        SIGNAL Clk
        SIGNAL B
        SIGNAL A
        SIGNAL Bcd(11:8)
        SIGNAL Bcd(7:4)
        SIGNAL Bcd(3:0)
        SIGNAL Clk_50Mhz
        SIGNAL Bcd(15:0)
        SIGNAL Dp(3:0)
        SIGNAL Segm(1:8)
        SIGNAL An(3:0)
        SIGNAL Dp(2)
        SIGNAL Dp(1)
        SIGNAL Dp(0)
        SIGNAL Dp(3)
        SIGNAL Bcd(15)
        SIGNAL Bcd(14)
        SIGNAL Bcd(13)
        SIGNAL Bcd(12)
        SIGNAL A_out
        SIGNAL B_out
        PORT Output F_Moore
        PORT Output F_Mealy
        PORT Output F_Async
        PORT Input Clk
        PORT Input B
        PORT Input A
        PORT Input Clk_50Mhz
        PORT Output Segm(1:8)
        PORT Output An(3:0)
        PORT Output A_out
        PORT Output B_out
        BEGIN BLOCKDEF Async_State_Machine
            TIMESTAMP 2007 9 26 17 11 1
            RECTANGLE N 320 20 384 44 
            LINE N 320 32 384 32 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            LINE N 320 -96 384 -96 
            RECTANGLE N 64 -128 320 64 
        END BLOCKDEF
        BEGIN BLOCKDEF Sync_Mealy_Machine
            TIMESTAMP 2007 9 26 17 11 8
            RECTANGLE N 320 20 384 44 
            LINE N 320 32 384 32 
            LINE N 64 -160 0 -160 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            LINE N 320 -160 384 -160 
            RECTANGLE N 64 -192 320 64 
        END BLOCKDEF
        BEGIN BLOCKDEF Sync_Moore_Machine
            TIMESTAMP 2007 9 26 17 11 15
            RECTANGLE N 320 20 384 44 
            LINE N 320 32 384 32 
            LINE N 64 -160 0 -160 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            LINE N 320 -160 384 -160 
            RECTANGLE N 64 -192 320 64 
        END BLOCKDEF
        BEGIN BLOCKDEF buf
            TIMESTAMP 2000 1 1 10 10 10
            LINE N 0 -32 64 -32 
            LINE N 224 -32 128 -32 
            LINE N 64 0 128 -32 
            LINE N 128 -32 64 -64 
            LINE N 64 -64 64 0 
        END BLOCKDEF
        BEGIN BLOCKDEF muxdisplay_ver3
            TIMESTAMP 2007 9 26 17 11 25
            RECTANGLE N 64 -192 320 0 
            LINE N 64 -160 0 -160 
            RECTANGLE N 0 -108 64 -84 
            LINE N 64 -96 0 -96 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            LINE N 320 -160 384 -160 
            RECTANGLE N 320 -108 384 -84 
            LINE N 320 -96 384 -96 
            RECTANGLE N 320 -44 384 -20 
            LINE N 320 -32 384 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF inv
            TIMESTAMP 2000 1 1 10 10 10
            LINE N 0 -32 64 -32 
            LINE N 224 -32 160 -32 
            LINE N 64 -64 128 -32 
            LINE N 128 -32 64 0 
            LINE N 64 0 64 -64 
            CIRCLE N 128 -48 160 -16 
        END BLOCKDEF
        BEGIN BLOCKDEF vcc
            TIMESTAMP 2000 1 1 10 10 10
            LINE N 64 -32 64 -64 
            LINE N 64 0 64 -32 
            LINE N 96 -64 32 -64 
        END BLOCKDEF
        BEGIN BLOCKDEF gnd
            TIMESTAMP 2000 1 1 10 10 10
            LINE N 64 -64 64 -96 
            LINE N 76 -48 52 -48 
            LINE N 68 -32 60 -32 
            LINE N 88 -64 40 -64 
            LINE N 64 -64 64 -80 
            LINE N 64 -128 64 -96 
        END BLOCKDEF
        BEGIN BLOCK U1 Async_State_Machine
            PIN A A
            PIN B B
            PIN F F_Async
            PIN State(3:0) Bcd(11:8)
        END BLOCK
        BEGIN BLOCK U3 Sync_Moore_Machine
            PIN A A
            PIN B B
            PIN Clk Clk
            PIN F F_Moore
            PIN State(3:0) Bcd(3:0)
        END BLOCK
        BEGIN BLOCK U2 Sync_Mealy_Machine
            PIN A A
            PIN B B
            PIN Clk Clk
            PIN F F_Mealy
            PIN State(3:0) Bcd(7:4)
        END BLOCK
        BEGIN BLOCK U4 muxdisplay_ver3
            PIN Clk_50MHz Clk_50Mhz
            PIN Bcd(15:0) Bcd(15:0)
            PIN Dp(3:0) Dp(3:0)
            PIN Clk_1kHz
            PIN Segm(1:8) Segm(1:8)
            PIN An(3:0) An(3:0)
        END BLOCK
        BEGIN BLOCK XLXI_16 inv
            PIN I F_Moore
            PIN O Dp(0)
        END BLOCK
        BEGIN BLOCK XLXI_14 inv
            PIN I F_Async
            PIN O Dp(2)
        END BLOCK
        BEGIN BLOCK XLXI_15 inv
            PIN I F_Mealy
            PIN O Dp(1)
        END BLOCK
        BEGIN BLOCK XLXI_17 vcc
            PIN P Dp(3)
        END BLOCK
        BEGIN BLOCK XLXI_23 vcc
            PIN P Bcd(15)
        END BLOCK
        BEGIN BLOCK XLXI_24 vcc
            PIN P Bcd(14)
        END BLOCK
        BEGIN BLOCK XLXI_20 gnd
            PIN G Bcd(13)
        END BLOCK
        BEGIN BLOCK XLXI_21 gnd
            PIN G Bcd(12)
        END BLOCK
        BEGIN BLOCK XLXI_4 buf
            PIN I B
            PIN O B_out
        END BLOCK
        BEGIN BLOCK XLXI_9 buf
            PIN I A
            PIN O A_out
        END BLOCK
    END NETLIST
    BEGIN SHEET 1 3520 2720
        BEGIN INSTANCE U1 592 416 R0
        END INSTANCE
        BEGIN BRANCH F_Moore
            WIRE 992 960 1024 960
            WIRE 1024 960 1024 1024
            WIRE 1024 1024 1040 1024
            WIRE 1024 960 1264 960
        END BRANCH
        BEGIN BRANCH F_Mealy
            WIRE 976 608 1008 608
            WIRE 1008 608 1008 688
            WIRE 1008 688 1024 688
            WIRE 1008 608 1264 608
        END BRANCH
        BEGIN BRANCH F_Async
            WIRE 976 320 1008 320
            WIRE 1008 320 1008 384
            WIRE 1008 384 1024 384
            WIRE 1008 320 1248 320
        END BRANCH
        BEGIN BRANCH Clk
            WIRE 352 960 400 960
            WIRE 400 960 400 1088
            WIRE 400 1088 608 1088
            WIRE 400 736 592 736
            WIRE 400 736 400 960
        END BRANCH
        BEGIN BRANCH B
            WIRE 336 384 432 384
            WIRE 432 384 592 384
            WIRE 432 384 432 672
            WIRE 432 672 432 1024
            WIRE 432 1024 608 1024
            WIRE 432 672 592 672
        END BRANCH
        BEGIN BRANCH A
            WIRE 336 320 464 320
            WIRE 464 320 592 320
            WIRE 464 320 464 608
            WIRE 464 608 464 960
            WIRE 464 960 608 960
            WIRE 464 608 592 608
        END BRANCH
        BEGIN INSTANCE U3 608 1120 R0
        END INSTANCE
        BEGIN INSTANCE U2 592 768 R0
        END INSTANCE
        BEGIN BRANCH Bcd(11:8)
            WIRE 976 448 1136 448
            BEGIN DISPLAY 1136 448 ATTR Name
                ALIGNMENT SOFT-LEFT
            END DISPLAY
        END BRANCH
        BEGIN BRANCH Bcd(7:4)
            WIRE 976 800 1136 800
            BEGIN DISPLAY 1136 800 ATTR Name
                ALIGNMENT SOFT-LEFT
            END DISPLAY
        END BRANCH
        BEGIN BRANCH Bcd(3:0)
            WIRE 992 1152 1136 1152
            BEGIN DISPLAY 1136 1152 ATTR Name
                ALIGNMENT SOFT-LEFT
            END DISPLAY
        END BRANCH
        BEGIN INSTANCE U4 624 1488 R0
        END INSTANCE
        BEGIN BRANCH Clk_50Mhz
            WIRE 560 1328 624 1328
        END BRANCH
        BEGIN BRANCH Bcd(15:0)
            WIRE 560 1392 624 1392
            BEGIN DISPLAY 560 1392 ATTR Name
                ALIGNMENT SOFT-RIGHT
            END DISPLAY
        END BRANCH
        BEGIN BRANCH Dp(3:0)
            WIRE 560 1456 624 1456
            BEGIN DISPLAY 560 1456 ATTR Name
                ALIGNMENT SOFT-RIGHT
            END DISPLAY
        END BRANCH
        BEGIN BRANCH Segm(1:8)
            WIRE 1008 1392 1152 1392
        END BRANCH
        BEGIN BRANCH An(3:0)
            WIRE 1008 1456 1152 1456
        END BRANCH
        INSTANCE XLXI_16 1040 1056 R0
        INSTANCE XLXI_14 1024 416 R0
        INSTANCE XLXI_15 1024 720 R0
        BEGIN BRANCH Dp(2)
            WIRE 1248 384 1296 384
            BEGIN DISPLAY 1296 384 ATTR Name
                ALIGNMENT SOFT-LEFT
            END DISPLAY
        END BRANCH
        BEGIN BRANCH Dp(1)
            WIRE 1248 688 1296 688
            BEGIN DISPLAY 1296 688 ATTR Name
                ALIGNMENT SOFT-LEFT
            END DISPLAY
        END BRANCH
        BEGIN BRANCH Dp(0)
            WIRE 1264 1024 1328 1024
            BEGIN DISPLAY 1328 1024 ATTR Name
                ALIGNMENT SOFT-LEFT
            END DISPLAY
        END BRANCH
        INSTANCE XLXI_17 496 1616 R0
        BEGIN BRANCH Dp(3)
            WIRE 560 1616 560 1648
            BEGIN DISPLAY 560 1648 ATTR Name
                ALIGNMENT SOFT-VRIGHT
            END DISPLAY
        END BRANCH
        INSTANCE XLXI_23 928 1600 R0
        INSTANCE XLXI_24 1008 1600 R0
        INSTANCE XLXI_20 1072 1760 R0
        INSTANCE XLXI_21 1136 1760 R0
        BEGIN BRANCH Bcd(15)
            WIRE 992 1600 992 1632
            BEGIN DISPLAY 992 1632 ATTR Name
                ALIGNMENT SOFT-VRIGHT
            END DISPLAY
        END BRANCH
        BEGIN BRANCH Bcd(14)
            WIRE 1072 1600 1072 1632
            BEGIN DISPLAY 1072 1632 ATTR Name
                ALIGNMENT SOFT-VRIGHT
            END DISPLAY
        END BRANCH
        BEGIN BRANCH Bcd(13)
            WIRE 1136 1616 1136 1632
            BEGIN DISPLAY 1136 1616 ATTR Name
                ALIGNMENT SOFT-VLEFT
            END DISPLAY
        END BRANCH
        BEGIN BRANCH Bcd(12)
            WIRE 1200 1616 1200 1632
            BEGIN DISPLAY 1200 1616 ATTR Name
                ALIGNMENT SOFT-VLEFT
            END DISPLAY
        END BRANCH
        INSTANCE XLXI_4 992 224 R0
        INSTANCE XLXI_9 992 144 R0
        BEGIN BRANCH A
            WIRE 928 112 992 112
            BEGIN DISPLAY 928 112 ATTR Name
                ALIGNMENT SOFT-RIGHT
            END DISPLAY
        END BRANCH
        BEGIN BRANCH B
            WIRE 928 192 992 192
            BEGIN DISPLAY 928 192 ATTR Name
                ALIGNMENT SOFT-RIGHT
            END DISPLAY
        END BRANCH
        BEGIN BRANCH A_out
            WIRE 1216 112 1232 112
            WIRE 1232 112 1280 112
        END BRANCH
        BEGIN BRANCH B_out
            WIRE 1216 192 1232 192
            WIRE 1232 192 1280 192
        END BRANCH
        IOMARKER 352 960 Clk R180 28
        IOMARKER 1152 1392 Segm(1:8) R0 28
        IOMARKER 1152 1456 An(3:0) R0 28
        IOMARKER 560 1328 Clk_50Mhz R180 28
        IOMARKER 1264 960 F_Moore R0 28
        IOMARKER 336 384 B R180 28
        IOMARKER 336 320 A R180 28
        IOMARKER 1248 320 F_Async R0 28
        IOMARKER 1280 192 B_out R0 28
        IOMARKER 1280 112 A_out R0 28
        IOMARKER 1264 608 F_Mealy R0 28
    END SHEET
END SCHEMATIC
