--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 9.2.02i
--  \   \         Application : sch2vhdl
--  /   /         Filename : Test_State_Machines.vhf
-- /___/   /\     Timestamp : 09/26/2007 19:24:02
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: C:\Xilinx92i\bin\nt\sch2vhdl.exe -intstyle ise -family spartan3e -flat -suppress -w D:/BASYS_PROJECTS/EXER4x/Exer4_1_Statemachines1/Test_State_Machines.sch Test_State_Machines.vhf
--Design Name: Test_State_Machines
--Device: spartan3e
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesis and simulted, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity Test_State_Machines is
   port ( A         : in    std_logic; 
          B         : in    std_logic; 
          Clk       : in    std_logic; 
          Clk_50Mhz : in    std_logic; 
          An        : out   std_logic_vector (3 downto 0); 
          A_out     : out   std_logic; 
          B_out     : out   std_logic; 
          F_Async   : out   std_logic; 
          F_Mealy   : out   std_logic; 
          F_Moore   : out   std_logic; 
          Segm      : out   std_logic_vector (1 to 8));
end Test_State_Machines;

architecture BEHAVIORAL of Test_State_Machines is
   attribute BOX_TYPE   : string ;
   signal Bcd           : std_logic_vector (15 downto 0);
   signal Dp            : std_logic_vector (3 downto 0);
   signal F_Async_DUMMY : std_logic;
   signal F_Moore_DUMMY : std_logic;
   signal F_Mealy_DUMMY : std_logic;
   component Async_State_Machine
      port ( A     : in    std_logic; 
             B     : in    std_logic; 
             F     : out   std_logic; 
             State : out   std_logic_vector (3 downto 0));
   end component;
   
   component Sync_Mealy_Machine
      port ( A     : in    std_logic; 
             B     : in    std_logic; 
             Clk   : in    std_logic; 
             F     : out   std_logic; 
             State : out   std_logic_vector (3 downto 0));
   end component;
   
   component Sync_Moore_Machine
      port ( A     : in    std_logic; 
             B     : in    std_logic; 
             Clk   : in    std_logic; 
             F     : out   std_logic; 
             State : out   std_logic_vector (3 downto 0));
   end component;
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   component muxdisplay_ver3
      port ( Clk_50MHz : in    std_logic; 
             Bcd       : in    std_logic_vector (15 downto 0); 
             Dp        : in    std_logic_vector (3 downto 0); 
             Clk_1kHz  : out   std_logic; 
             Segm      : out   std_logic_vector (1 to 8); 
             An        : out   std_logic_vector (3 downto 0));
   end component;
   
   component INV
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of INV : component is "BLACK_BOX";
   
   component VCC
      port ( P : out   std_logic);
   end component;
   attribute BOX_TYPE of VCC : component is "BLACK_BOX";
   
   component GND
      port ( G : out   std_logic);
   end component;
   attribute BOX_TYPE of GND : component is "BLACK_BOX";
   
begin
   F_Async <= F_Async_DUMMY;
   F_Mealy <= F_Mealy_DUMMY;
   F_Moore <= F_Moore_DUMMY;
   XLXI_1 : Async_State_Machine
      port map (A=>A,
                B=>B,
                F=>F_Async_DUMMY,
                State(3 downto 0)=>Bcd(11 downto 8));
   
   XLXI_2 : Sync_Mealy_Machine
      port map (A=>A,
                B=>B,
                Clk=>Clk,
                F=>F_Mealy_DUMMY,
                State(3 downto 0)=>Bcd(7 downto 4));
   
   XLXI_3 : Sync_Moore_Machine
      port map (A=>A,
                B=>B,
                Clk=>Clk,
                F=>F_Moore_DUMMY,
                State(3 downto 0)=>Bcd(3 downto 0));
   
   XLXI_4 : BUF
      port map (I=>B,
                O=>B_out);
   
   XLXI_9 : BUF
      port map (I=>A,
                O=>A_out);
   
   XLXI_12 : muxdisplay_ver3
      port map (Bcd(15 downto 0)=>Bcd(15 downto 0),
                Clk_50MHz=>Clk_50Mhz,
                Dp(3 downto 0)=>Dp(3 downto 0),
                An(3 downto 0)=>An(3 downto 0),
                Clk_1kHz=>open,
                Segm(1 to 8)=>Segm(1 to 8));
   
   XLXI_14 : INV
      port map (I=>F_Async_DUMMY,
                O=>Dp(2));
   
   XLXI_15 : INV
      port map (I=>F_Mealy_DUMMY,
                O=>Dp(1));
   
   XLXI_16 : INV
      port map (I=>F_Moore_DUMMY,
                O=>Dp(0));
   
   XLXI_17 : VCC
      port map (P=>Dp(3));
   
   XLXI_20 : GND
      port map (G=>Bcd(13));
   
   XLXI_21 : GND
      port map (G=>Bcd(12));
   
   XLXI_23 : VCC
      port map (P=>Bcd(15));
   
   XLXI_24 : VCC
      port map (P=>Bcd(14));
   
end BEHAVIORAL;


