-- Vhdl test bench created from schematic D:\XilinxPro\Exer11\Exer4x\Ecer_4_1_StateMachines\StateMachines\Test_State_Machines.sch - Mon Jul 20 13:28:46 2009
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
ENTITY Test_State_Machines_Test_State_Machines_sch_tb IS
END Test_State_Machines_Test_State_Machines_sch_tb;
ARCHITECTURE behavioral OF Test_State_Machines_Test_State_Machines_sch_tb IS 

   COMPONENT Test_State_Machines
   PORT( F_Moore	:	OUT	STD_LOGIC; 
          F_Mealy	:	OUT	STD_LOGIC; 
          F_Async	:	OUT	STD_LOGIC; 
          Clk	:	IN	STD_LOGIC; 
          B	:	IN	STD_LOGIC; 
          A	:	IN	STD_LOGIC; 
          Clk_50Mhz	:	IN	STD_LOGIC; 
          Segm	:	OUT	STD_LOGIC_VECTOR (1 TO 8); 
          An	:	OUT	STD_LOGIC_VECTOR (3 DOWNTO 0); 
          A_out	:	OUT	STD_LOGIC; 
          B_out	:	OUT	STD_LOGIC);
   END COMPONENT;

   SIGNAL F_Moore	:	STD_LOGIC;
   SIGNAL F_Mealy	:	STD_LOGIC;
   SIGNAL F_Async	:	STD_LOGIC;
   SIGNAL Clk	:	STD_LOGIC;
   SIGNAL B	:	STD_LOGIC;
   SIGNAL A	:	STD_LOGIC;
   SIGNAL Clk_50Mhz	:	STD_LOGIC := '0';
   SIGNAL Segm	:	STD_LOGIC_VECTOR (1 TO 8);
   SIGNAL An	:	STD_LOGIC_VECTOR (3 DOWNTO 0);
   SIGNAL A_out	:	STD_LOGIC;
   SIGNAL B_out	:	STD_LOGIC;

BEGIN

   UUT: Test_State_Machines PORT MAP(
		F_Moore => F_Moore, 
		F_Mealy => F_Mealy, 
		F_Async => F_Async, 
		Clk => Clk, 
		B => B, 
		A => A, 
		Clk_50Mhz => Clk_50Mhz, 
		Segm => Segm, 
		An => An, 
		A_out => A_out, 
		B_out => B_out
   );

-- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN
	   A <= '0'; B <= '0'; Clk <='0'; 
		Wait for 50 ns;
		-----------------------____--___ Clk pulse ------------------
		Clk <= '1';   Wait for 10 ns;  Clk <= '0';  wait for 40 ns;	
      -------------------------------------------------------------		
	   A <= '1'; B <= '0';
		Wait for 50 ns;
		-----------------------____--___ Clk pulse ------------------
		Clk <= '1';   Wait for 10 ns;  Clk <= '0';  wait for 40 ns;	
      -------------------------------------------------------------	
	   A <= '1'; B <= '1';
		Wait for 50 ns;
		-----------------------____--___ Clk pulse ------------------
		Clk <= '1';   Wait for 10 ns;  Clk <= '0';  wait for 40 ns;	
      -------------------------------------------------------------
	   A <= '1'; B <= '0';
		Wait for 50 ns;
		-----------------------____--___ Clk pulse ------------------
		Clk <= '1';   Wait for 10 ns;  Clk <= '0';  wait for 40 ns;	
      -------------------------------------------------------------
	   A <= '0'; B <= '0';
		Wait for 50 ns;
		-----------------------____--___ Clk pulse ------------------
		Clk <= '1';   Wait for 10 ns;  Clk <= '0';  wait for 40 ns;	
      -------------------------------------------------------------
	   A <= '0'; B <= '1';
		Wait for 50 ns;
		-----------------------____--___ Clk pulse ------------------
		Clk <= '1';   Wait for 10 ns;  Clk <= '0';  wait for 40 ns;	
      -------------------------------------------------------------	
	   A <= '1'; B <= '1';
		Wait for 50 ns;
		-----------------------____--___ Clk pulse ------------------
		Clk <= '1';   Wait for 10 ns;  Clk <= '0';  wait for 40 ns;	
      -------------------------------------------------------------		
      WAIT; -- will wait forever
   END PROCESS;
-- *** End Test Bench - User Defined Section ***

END;
