----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity proj2 is
port (clk : in std_logic;
      cycle : out std_logic_vector(2 downto 0);
      outval : out std_logic
      );
end proj2;

architecture Behavioral of proj2 is
	type statetype is (s0,s1,s2,s3,s4,s5,s6,s7);
	signal state, nextstate : statetype;
	signal reset : std_logic;
begin
	
	process(state)
	begin
		if (reset = '0') then
			nextstate <= s0;
		else
			if (state = s0) then
				nextstate <= s1;
			elsif (state = s1) then
				nextstate <= s2;
			elsif (state = s2) then
				nextstate <= s3;
			elsif (state = s3) then
				nextstate <= s4;
			elsif (state = s4) then
				nextstate <= s5;
			elsif (state = s5) then
				nextstate <=s6;
			elsif (state = s6) then
				nextstate <= s7;
			else
				nextstate <= s0;
			end if;
		end if;
	end process;
	
	process(state)
	begin
		case state is
		
			when s0 => 
			cycle <= "000"; 
			reset <= '1';
			outval <= '1';
			
			when s1 => 
			cycle <= "001";
			outval <= '1';
			
			when s2 => 
			cycle <= "010";
			outval <= '1';
			
			when s3 => 
			cycle <= "011";
			outval <= '1';
			
			when s4 => 
			cycle <= "100";
			outval <= '0';
			
			when s5 => 
			cycle <= "101";
			outval <= '0';
			
			when s6 => 
			cycle <= "110";
			outval <= '0';
			
			when s7 => 
			cycle <= "111";
			
		end case;
	end process;
	
	process(clk,nextstate)
	begin
		if (clk'event and clk = '0') then
			state <= nextstate;
		end if;
	end process;

end Behavioral;
